6 # I use this in EVERY shell script ;)
11 while ! [ -f ./all ]; do
12 if [ x"`pwd`" = x"/" ]; then
13 echo "Cannot find myself."
14 echo "Please run this script with the working directory inside a Xonotic checkout."
22 # If we are on WINDOWS:
27 # Windows hates users. So this script has to copy itself elsewhere first...
28 cp "$SELF" ../all.xonotic.sh
29 export WE_HATE_OUR_USERS=1
30 exec ../all.xonotic.sh "$@"
41 self=`git hash-object "$SELF"`
44 self_new=`git hash-object "$SELF"`
45 if [ x"$self" != x"$self_new" ]; then
46 msg "./all has changed."
47 if [ -z "$XONOTIC_FORBID_RERUN_ALL" ]; then
48 msg "Rerunning the requested operation to make sure."
49 export XONOTIC_FORBID_RERUN_ALL=1
52 msg "Please try $SELF update, and then retry your requested operation."
69 echo "the root directory"
79 if git ls-files -u | grep ' 1 '; then
81 echo "MERGE CONFLICT."
82 echo "change into the \"$1\" project directory, and then:"
83 echo "- edit the files mentioned above with your favorite editor,"
84 echo " and fix the conflicts (marked with <<<<<<< blocks)"
85 echo "- for binary files, you can select the files using"
86 echo " git checkout --ours or git checkout --theirs"
87 echo "- when done with a file, 'git add' the file"
88 echo "- when done, 'git commit'"
97 while [ x"$yesno" != x"y" -a x"$yesno" != x"n" ]; do
108 check_mergeconflict "$1"
113 data/xonotic-data.pk3dir | | master |
114 data/xonotic-maps.pk3dir | | master |
115 data/xonotic-music.pk3dir | | master |
116 data/xonotic-nexcompat.pk3dir | | master |
117 mediasource | | master |
118 darkplaces | | div0-stable | svn
119 fteqcc | git://github.com/Blub/qclib.git | master |
120 div0-gittools | | master |
121 netradiant | | master |
123 # todo: in darkplaces, change repobranch to div0-stable
125 repos=`echo "$repos_urls" | grep . | cut -d '|' -f 1 | tr -d ' '`
127 base=`git config remote.origin.url`
130 base=${base%xonotic.git}
133 echo "The main repo is not xonotic.git, what have you done?"
140 repo_t=`echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 2 | tr -d ' '`
141 if [ -n "$repo_t" ]; then
151 if [ x"$1" = x"." ]; then
152 echo "$base""xonotic.git"
154 echo "$base${1##*/}.git"
161 repo_t=`echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 3 | tr -d ' '`
162 if [ -n "$repo_t" ]; then
171 echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 4 | tr -d ' '
174 repos=`for d in $repos; do
176 if [ x"$p" = x"$d" ] || [ -d "$d" ] || ! { [ -f "$d.no" ] || [ -f "$p" ]; }; then
181 if [ "$#" = 0 ]; then
187 fix_upstream_rebase()
189 if [ -z "$r_me" ] || [ -z "$r_other" ]; then
192 r_base=`git merge-base "$r_me" "$r_other"`
194 # no merge-base? upstream did filter-branch
195 if [ -n "$r_base" ]; then
196 # otherwise, check if the two histories are "similar"
197 r_l_me=`git log --pretty="format:%s" "$r_other".."$r_me" | grep -v "^Merge" | sort -u`
198 r_l_other=`git log --pretty="format:%s" "$r_me".."$r_other" | grep -v "^Merge" | sort -u`
200 # heuristics: upstream rebase/filter-branch if more than 50% of the commits of one of the sides are in the other too
201 r_lc_me=`echo "$r_l_me" | wc -l`
202 r_lc_other=`echo "$r_l_other" | wc -l`
203 r_lc_together=`{ echo "$r_l_me"; echo "$r_l_other"; } | sort -u | wc -l`
204 r_lc_same=$(($r_lc_me + $r_lc_other - $r_lc_together))
206 if [ $(( $r_lc_same * 2 )) -gt $(( $r_lc_me )) ] || [ $(( $r_lc_same * 2 )) -gt $(( $r_lc_other )) ]; then
207 if yesno "Probable upstream rebase detected, automatically fix?" 'git log --oneline --graph --date-order --left-right "$r_other"..."$r_me"'; then
208 git reset --hard "$r_me"
218 fix_upstream_rebase_mergeok()
220 r_me=`git rev-parse --revs-only HEAD^1 2>/dev/null || true`
221 r_other=`git rev-parse --revs-only HEAD^2 2>/dev/null || true`
225 fix_upstream_rebase_mergefail()
227 r_me=`git rev-parse --revs-only HEAD 2>/dev/null || true`
228 r_other=`git rev-parse --revs-only MERGE_HEAD 2>/dev/null || true`
235 enter "$d0/$d" verbose
236 verbose fix_upstream_rebase_mergefail && verbose fix_upstream_rebase_mergeok
241 if [ x"$1" = x"-N" ]; then
246 branch=`repobranch "$d"`
247 if [ -d "$d0/$d" ]; then
249 enter "$d0/$d" verbose
250 verbose git config remote.origin.url "$url"
251 verbose git config remote.origin.fetch "+refs/heads/*:refs/remotes/origin/*"
253 verbose git config remote.origin.autocrlf input
255 r=`git symbolic-ref HEAD`
257 if git config branch.$r.remote >/dev/null 2>&1; then
258 if ! verbose git pull; then
259 fix_upstream_rebase_mergefail || true
260 check_mergeconflict "$d"
261 echo "Pulling failed. Press ENTER to continue, or Ctrl-C to abort."
264 fix_upstream_rebase_mergeok || true
269 checkself "$cmd" "$@"
271 verbose git remote prune origin
275 verbose git clone "$url" "$d0/$d"
276 enter "$d0/$d" verbose
277 if [ "$branch" != "master" ]; then
278 verbose git checkout --track -b "$branch" origin/"$branch"
285 misc/tools/xonotic-map-compiler-autobuild download
290 if [ -z "$branch" ]; then
293 branch=${remote#origin/}
304 enter "$d0/$d" verbose
306 if [ -n "$b" ] && git rev-parse "refs/heads/$b" >/dev/null 2>&1; then
308 verbose git checkout "$b"
309 elif [ -n "$b" ] && git rev-parse "refs/remotes/$remote/$b" >/dev/null 2>&1; then
311 verbose git checkout --track -b "$b" "$remote/$b"
314 if git rev-parse "refs/heads/$b" >/dev/null 2>&1; then
316 verbose git checkout "$b"
317 elif git rev-parse "refs/remotes/$remote/$b" >/dev/null 2>&1; then
319 verbose git checkout --track -b "$b" "$remote/$b"
321 echo "WTF? Not even branch $b doesn't exist in $d"
326 checkself "$cmd" "$@"
330 echo "The requested branch was not found in any repository."
338 if [ -z "$branch" ]; then
342 if [ -z "$branch" ]; then
345 r=`git symbolic-ref HEAD`
352 dv=`visible_repo_name "$d"`
353 enter "$d0/$d" verbose
354 if git rev-parse "refs/heads/$branch" >/dev/null 2>&1; then
355 echo "Already having this branch in $dv."
357 if yesno "Branch in $dv?"; then
358 if [ -n "$srcbranch" ]; then
361 b=origin/"`repobranch "$d"`"
362 verbose git fetch origin || true
364 # TODO do this without pushing
365 verbose git checkout -b "$branch" "$b"
366 verbose git config "branch.$branch.remote" "$remote"
367 verbose git config "branch.$branch.merge" "refs/heads/$branch"
377 cd "$d0/$d" # am in a pipe, shouldn't use enter
378 git branch -a -v -v | cut -c 3- | sed "s/^(no branch)/(no_branch)/" | sed "s,^,$d ,"
383 while read -r d BRANCH REV UPSTREAM TEXT; do
384 if [ x"$BRANCH" = x"`repobranch "$d"`" ]; then
389 UPSTREAM=${UPSTREAM#\[}
390 UPSTREAM=${UPSTREAM%\]}
391 UPSTREAM=${UPSTREAM%:*}
394 TEXT="$UPSTREAM $TEXT"
398 if [ x"$REV" = x"->" ]; then
401 BRANCH=${BRANCH#remotes/}
402 ID=`echo "$BRANCH" | tr -c "A-Za-z0-9." "_"`
403 branches_list="$branches_list $BRANCH" # TEH SORT MAKEZ IT UNIEQ
404 eval "r=\$branches_repos_$ID"
413 eval "branches_repos_$ID=\$r"
415 echo -n "$branches_list" | xargs -n 1 echo | sort -u | while IFS= read -r BRANCH; do
416 ID=`echo "$BRANCH" | tr -c "A-Za-z0-9." "_"`
417 eval "r=\$branches_repos_$ID"
418 printf "%-60s %s\n" "$BRANCH" "$r"
425 dv=`visible_repo_name "$d"`
426 enter "$d0/$d" verbose
427 r=`git symbolic-ref HEAD`
429 if git log HEAD..origin/"`repobranch "$d"`" | grep .; then
430 # we have uncommitted changes
431 if yesno "Could merge from \"`repobranch "$d"`\" into \"$r\" in $dv. Do it?"; then
432 if ! verbose git merge origin/"`repobranch "$d"`"; then
433 check_mergeconflict "$d"
434 exit 1 # this should ALWAYS be fatal
444 dv=`visible_repo_name "$d"`
445 enter "$d0/$d" verbose
446 r=`git symbolic-ref HEAD`
448 diffdata=`git diff --color HEAD`
449 if [ -n "$diffdata" ]; then
450 # we have uncommitted changes
451 if yesno "Uncommitted changes in \"$r\" in $dv. Commit?" 'echo "$diffdata" | less -r'; then
452 verbose git commit -a
455 rem=`git config "branch.$r.remote" || echo origin`
456 bra=`git config "branch.$r.merge" || echo "$r"`
457 upstream="$rem/${bra#refs/heads/}"
458 if ! git rev-parse "$upstream" >/dev/null 2>&1; then
459 upstream="origin/`repobranch "$d"`"
461 logdata=`git log --color "$upstream".."$r"`
462 if [ -n "$logdata" ]; then
463 if yesno "Push \"$r\" in $dv?" 'echo "$logdata" | less -r'; then
464 verbose git push "$rem" HEAD
467 if [ x"$submit" = x"-s" ]; then
470 verbose git push "$rem" HEAD:"${bra%%/*}/finished/${bra#*/}"
478 if [ -n "$WE_HATE_OUR_USERS" ]; then
479 TARGETS="sv-debug cl-debug"
480 if [ -z "$CC" ]; then
483 elif [ x"`uname`" = x"Darwin" ]; then
486 TARGETS="sv-debug cl-debug sdl-debug"
489 # AGL cannot be compiled on systems with a kernel > 10.x (Snow Leopard)
490 TARGETS="sv-debug sdl-debug"
493 export CC="gcc -I$PWD/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks/SDL.framework/Headers -F$PWD/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks"
495 TARGETS="sv-debug cl-debug sdl-debug"
513 cleanqc=true # version info
516 if [ $# -gt 0 ] && [ x"$1" = x"" ]; then
517 # if we give the command make the arg "", it will surely fail (invalid filename),
518 # so better handle it as an empty client option
521 elif [ -n "$1" ]; then
523 TARGETS_SAVE=$TARGETS
528 TARGETS="$TARGETS sdl-debug"
531 TARGETS="$TARGETS cl-debug"
534 TARGETS="$TARGETS sv-debug"
537 BAD_TARGETS="$BAD_TARGETS $X"
541 if [ -n "$TARGETS" ]; then # at least a valid client
543 else # no valid client, let's assume this option is not meant to be a client then
544 TARGETS=$TARGETS_SAVE
548 if [ -z "$MAKEFLAGS" ]; then
549 if [ -f /proc/cpuinfo ]; then
550 ncpus=$((`grep -c '^processor :' /proc/cpuinfo`+0))
551 if [ $ncpus -gt 1 ]; then
557 MAKEFLAGS="$MAKEFLAGS DP_LINK_TO_LIBJPEG=1"
560 if [ -n "$WE_HATE_OUR_USERS" ]; then
561 MAKEFLAGS="$MAKEFLAGS DP_MAKE_TARGET=mingw"
565 enter "$d0/fteqcc" verbose
567 verbose make $MAKEFLAGS clean
569 verbose make $MAKEFLAGS
571 enter "$d0/data/xonotic-data.pk3dir" verbose
573 verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" "$@" $MAKEFLAGS clean
575 verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" "$@" $MAKEFLAGS
577 enter "$d0/darkplaces" verbose
578 if [ x"$BAD_TARGETS" = x" " ]; then
579 echo "Warning: invalid empty client, default clients will be used."
582 verbose make $MAKEFLAGS clean
584 for T in $TARGETS; do
585 verbose make $MAKEFLAGS "$@" "$T"
587 for T in $BAD_TARGETS; do
588 echo "Warning: discarded invalid client $T."
591 verbose "$SELF" update-maps
594 if [ -n "$WE_HATE_OUR_USERS" ]; then
596 export PATH="$d0/misc/buildfiles/win64:$d0/misc/buildfiles/win32:$PATH"
597 elif [ x"`uname`" = x"Darwin" ]; then
598 export DYLD_LIBRARY_PATH="$d0/misc/buildfiles/osx/Xonotic-SDL.app/Contents/MacOS"
599 export DYLD_FRAMEWORK_PATH="$d0/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks"
605 sdl|glx|agl|dedicated)
614 if ! [ -x "darkplaces/darkplaces$client" ]; then
615 if [ -x "darkplaces/darkplaces$client.exe" ]; then
618 echo "Client darkplaces/darkplaces$client not found, aborting"
622 set -- "darkplaces/darkplaces$client" -nexuiz -customgamename Xonotic -customgamedirname1 data -customgamedirname2 "" -customgamescreenshotname xonotic -customgameuserdirname xonotic -mygames "$@"
624 # if pulseaudio is running: USE IT
625 if [ -z "$SDL_AUDIODRIVER" ] && ! [ -n "$WE_HATE_OUR_USERS" ] && ! [ x"`uname`" = x"Darwin" ]; then
626 if ps -C pulseaudio >/dev/null; then
627 if ldd /usr/lib/libSDL.so 2>/dev/null | grep pulse >/dev/null; then
628 export SDL_AUDIODRIVER=pulse
633 if [ -n "$USE_GDB" ]; then
634 set -- gdb --args "$@"
640 if [ x"$1" = x"-k" ]; then
645 if verbose cd "$d0/$d"; then
657 patchdir=`mktemp -d -t save-patches.XXXXXX`
659 enter "$d0/$d" verbose
660 git branch -v -v | cut -c 3- | {
662 while read -r BRANCH REV UPSTREAM TEXT; do
665 UPSTREAM=${UPSTREAM#\[}
666 UPSTREAM=${UPSTREAM%\]}
667 UPSTREAM=${UPSTREAM%:*}
671 UPSTREAM=origin/"`repobranch "$d"`"
675 if [ x"$REV" = x"->" ]; then
678 if git format-patch -o "$patchdir/$i" "$UPSTREAM".."$BRANCH"; then
679 echo "$d" > "$patchdir/$i/info.txt"
680 echo "$BRANCH" >> "$patchdir/$i/info.txt"
681 echo "$UPSTREAM" >> "$patchdir/$i/info.txt"
682 echo "$TRACK" >> "$patchdir/$i/info.txt"
685 rm -rf "$patchdir/$i"
690 ( cd "$patchdir" && tar cvzf - . ) > "$outfile"
695 patchdir=`mktemp -d -t restore-patches.XXXXXX`
696 ( cd "$patchdir" && tar xvzf - ) < "$infile"
698 for P in "$patchdir"/*/info.txt; do
705 verbose git checkout HEAD^0
706 verbose git branch -D "$BRANCH"
707 if [ x"$TRACK" = x"true" ]; then
708 verbose git checkout --track -b "$BRANCH" "$UPSTREAM"
710 verbose git branch -b "$BRANCH" "$UPSTREAM"
722 report=$report"$*$LF"
727 report=$report" $*$LF"
732 o=`"$@" | sed 's/^/ /' || true`
736 enter "$d0/$d" verbose
737 base="`repobranch "$d"`"
739 for ref in `git for-each-ref --format='%(refname)' refs/remotes/origin/`; do
740 case "${ref#refs/remotes/origin/}" in
753 if [ -n "$branch" ]; then
754 if [ x"$branch" != x"${ref#refs/remotes/origin/}" ]; then
763 l0=`git rev-list "$base".."$ref" | wc -l`
764 l1=`git rev-list master.."$ref" | wc -l`
765 if [ $l0 -gt $l1 ]; then
772 reportecho " Branch $ref:"
773 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
774 logdata=`git log --color "$realbase".."$ref"`
775 if [ -z "$logdata" ]; then
776 reportecho4 "--> not merging, no changes vs master"
777 if yesno "Branch \"$ref\" probably should get deleted. Do it?" ''; then
778 git push origin :"${ref#refs/remotes/origin/}"
779 reportecho4 "--> branch deleted"
782 diffdata=`git diff --color --find-copies-harder --ignore-space-change "$realbase"..."$ref"`
783 if [ -z "$diffdata" ]; then
784 reportecho4 "--> not merging, no changes vs master, branch contains redundant history"
785 if yesno "Branch \"$ref\" probably should get deleted. Do it?" '{ echo "$logdata"; } | less -r'; then
786 git push origin :"${ref#refs/remotes/origin/}"
787 reportecho4 "--> branch deleted"
789 elif [ -z "$branch" ] && [ -n "$note" ]; then
790 reportdo4 echo "$note"
791 reportecho4 "--> not merging, already had this one rejected before"
792 elif yesno "Branch \"$ref\" may want to get merged. Do it?" '{ echo "$logdata"; echo "$diffdata"; } | less -r'; then
793 git checkout "$realbase"
794 org=`git rev-parse HEAD`
795 if ! git merge --no-ff "$ref" 2>&1 | tee "$t" && ! { git ls-files -u | grep ' 1 ' >/dev/null; }; then
796 git reset --hard "$org"
797 GIT_NOTES_REF=refs/notes/admin-merge git notes edit -m "Merge failed:$LF`cat "$t"`" "$ref"
799 reportecho4 "--> merge failed"
800 elif ! "$SELF" compile -n 2>&1 | tee "$t"; then
801 git reset --hard "$org"
802 GIT_NOTES_REF=refs/notes/admin-merge git notes edit -m "Compile failed:$LF`cat "$t"`" "$ref"
804 reportecho4 "--> compile failed"
805 elif ! yesno "Still merge \"$ref\" into `git symbolic-ref HEAD` of $d? Maybe you want to test first."; then
806 git reset --hard "$org"
807 GIT_NOTES_REF=refs/notes/admin-merge git notes edit "$ref"
808 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
809 if [ x"$note" = x"del" ]; then
810 git push origin :"${ref#refs/remotes/origin/}"
811 reportecho4 "--> test failed, branch deleted"
812 elif [ -n "$note" ]; then
813 reportdo4 echo "$note"
814 reportecho4 "--> test failed"
816 reportecho4 "--> test failed, postponed"
820 case ",`repoflags "$d"`," in
822 # we do quite a mess here... luckily we know $org
823 git fetch # svn needs to be current
824 git rebase -i --onto origin/master "$org"
825 git svn dcommit --add-author-from
826 git reset --hard "$org"
832 reportecho4 "--> MERGED"
833 if yesno "Delete original branch \"$ref\"?"; then
834 git push origin :"${ref#refs/remotes/origin/}"
835 reportecho4 "--> branch deleted"
839 GIT_NOTES_REF=refs/notes/admin-merge git notes edit "$ref"
840 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
841 if [ x"$note" = x"del" ]; then
842 git push origin :"${ref#refs/remotes/origin/}"
843 reportecho4 "--> branch deleted"
844 elif [ -n "$note" ]; then
845 reportdo4 echo "$note"
846 reportecho4 "--> rejected"
848 reportecho4 "--> postponed"
857 echo "$report" | ssh nexuiz@rm.endoftheinternet.org cat '>>' public_html/xonotic-merge-notes.txt
860 # release building goes here
862 #"$SELF" each git clean -fxd
863 rm -rf Xonotic Xonotic*.zip
865 date +%Y%m%d > Xonotic/stamp.txt
866 git archive --format=tar HEAD -- Docs misc server xonotic-linux-glx.sh xonotic-linux-sdl.sh misc/buildfiles | {
868 mkdir data fteqcc darkplaces-src fteqcc-src
870 rm -rf misc/builddeps
871 mv misc/buildfiles/win32/* . || true
872 mv misc/buildfiles/win64/* . || true
873 mv misc/buildfiles/osx/* . || true
874 rm -rf misc/buildfiles
878 git archive --format=tar HEAD
880 cd Xonotic/darkplaces-src
885 git archive --format=tar HEAD
887 cd Xonotic/fteqcc-src
898 case " $HOSTS_THAT_ARE_MYSELF " in
900 rsync --delete -zvaSHPAX "$srcdir"/ "$buildpath/"
903 verbose eval make clean $maketargets $makeflags
905 for f in $targetfiles; do
906 verbose mv "$buildpath/${f%:*}" "${f##*:}" || true
910 rsync --delete -zvaSHPAX "$srcdir"/ "$host:$buildpath/"
911 verbose ssh "$host" ". ~/.profile && cd $buildpath && make clean $maketargets $makeflags"
912 for f in $targetfiles; do
913 verbose rsync -zvaSHPAX "$host:$buildpath/${f%:*}" "${f##*:}" || true
917 # now rebrand the binaries...
918 for f in $targetfiles; do
919 verbose "$d0/misc/tools/rebrand-darkplaces-engine.sh" "$d0/misc/tools/xonotic.brand" "${f##*:}" || true
925 fteqcc_maketargets=$3
927 darkplaces_maketargets=$5
929 "$SELF" release-compile-run "xonotic-build-$suffix" /tmp/fteqcc.build."$suffix" "$fteqcc_maketargets" "$makeflags" "Xonotic/fteqcc-src" "$fteqcc_files"
930 "$SELF" release-compile-run "xonotic-build-$suffix" /tmp/Darkplaces.build."$suffix" "$darkplaces_maketargets" "$makeflags" "Xonotic/darkplaces-src" "$darkplaces_files"
932 release-engine-win32)
933 "$SELF" release-compile win32 \
934 'DP_MAKE_TARGET=mingw CC="i586-mingw32msvc-gcc -Wl,--dynamicbase -Wl,--nxcompat -g -DSUPPORTDIRECTX -DUSE_WSPIAPI_H -I$HOME/dp.win32/include -L$HOME/dp.win32/lib" WINDRES="i586-mingw32msvc-windres" SDL_CONFIG="$HOME/dp.win32/bin/sdl-config"' \
935 win 'fteqcc.exe:Xonotic/fteqcc/fteqcc.exe' \
936 debug 'darkplaces.exe:Xonotic/xonotic.exe darkplaces-sdl.exe:Xonotic/xonotic-sdl.exe darkplaces-dedicated.exe:Xonotic/xonotic-dedicated.exe'
938 release-engine-win64)
939 "$SELF" release-compile win64 \
940 'DP_MAKE_TARGET=mingw CC="amd64-mingw32msvc-gcc -Wl,--dynamicbase -Wl,--nxcompat -g -DSUPPORTDIRECTX -DUSE_WSPIAPI_H -I$HOME/dp.win64/include -L$HOME/dp.win64/lib" WINDRES="amd64-mingw32msvc-windres" SDL_CONFIG="$HOME/dp.win64/bin/sdl-config" LDFLAGS_WINCOMMON=""' \
941 win 'fteqcc.exe:Xonotic/fteqcc/fteqcc-64.exe' \
942 debug 'darkplaces.exe:Xonotic/xonotic-64.exe darkplaces-sdl.exe:Xonotic/xonotic-sdl-64.exe darkplaces-dedicated.exe:Xonotic/xonotic-dedicated-64.exe'
945 "$SELF" release-compile osx \
946 'CC="gcc -g -arch i386 -arch ppc -arch x86_64 -isysroot /Developer/SDKs/MacOSX10.5.sdk -mmacosx-version-min=10.5 -I$HOME/dp.osx/include -L$HOME/dp.osx/lib"' \
947 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.osx' \
948 sdl-debug 'darkplaces-sdl:Xonotic/Xonotic-SDL.app/Contents/MacOS/xonotic-osx-sdl-bin'
950 release-engine-linux32)
951 "$SELF" release-compile linux32 \
952 'CC="gcc -m32 -g -Wl,--hash-style=sysv -I$HOME/dp.linux32/include -L$HOME/dp.linux32/lib" DP_MODPLUG_STATIC_LIBDIR=$HOME/dp.linux32/lib DP_LINK_TO_LIBJPEG=1' \
953 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.linux32' \
954 debug 'darkplaces-glx:Xonotic/xonotic-linux32-glx darkplaces-sdl:Xonotic/xonotic-linux32-sdl darkplaces-dedicated:Xonotic/xonotic-linux32-dedicated'
956 release-engine-linux64)
957 "$SELF" release-compile linux64 \
958 'CC="gcc -m64 -g -Wl,--hash-style=sysv -I$HOME/dp.linux64/include -L$HOME/dp.linux64/lib" DP_MODPLUG_STATIC_LIBDIR=$HOME/dp.linux64/lib DP_LINK_TO_LIBJPEG=1' \
959 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.linux64' \
960 debug 'darkplaces-glx:Xonotic/xonotic-linux64-glx darkplaces-sdl:Xonotic/xonotic-linux64-sdl darkplaces-dedicated:Xonotic/xonotic-linux64-dedicated'
963 "$SELF" release-engine-win32 &
964 "$SELF" release-engine-win64 &
965 "$SELF" release-engine-osx &
966 "$SELF" release-engine-linux32 &
967 "$SELF" release-engine-linux64 &
974 verbose make -C data/xonotic-data.pk3dir FTEQCC="$d0/Xonotic/fteqcc/fteqcc.linux32" FTEQCCFLAGS_WATERMARK=
976 release-buildpk3-transform-raw)
979 release-buildpk3-transform-normal)
982 # texture: convert to jpeg and dds
984 export jpeg_qual_rgb=95
985 export jpeg_qual_a=99
990 find . -type f -print0 | xargs -0 "$d0"/misc/tools/cached-converter.sh
992 release-buildpk3-transform-low)
995 # texture: convert to jpeg and dds
996 # music: reduce bitrate
998 export jpeg_qual_rgb=80
999 export jpeg_qual_a=95
1004 find . -type f -print0 | xargs -0 "$d0"/misc/tools/cached-converter.sh
1006 release-buildpk3-transform-lowdds)
1009 # texture: convert to jpeg and dds
1010 # music: reduce bitrate
1011 export do_jpeg=false
1012 export do_jpeg_if_not_dds=true
1013 export jpeg_qual_rgb=80
1014 export jpeg_qual_a=95
1020 find . -type f -print0 | xargs -0 "$d0"/misc/tools/cached-converter.sh
1021 if [ -f "quake.rc" ]; then
1022 echo "r_texture_dds_load 1" >> quake.rc
1037 mkdir -p Xonotic/temp
1040 git archive --format=tar HEAD
1045 if [ x"$src" = x"data/xonotic-data.pk3dir" ]; then
1046 cp "$src"/progs.dat Xonotic/temp/
1047 cp "$src"/csprogs.dat Xonotic/temp/
1048 cp "$src"/menu.dat Xonotic/temp/
1050 if [ x"$src" = x"data/xonotic-maps.pk3dir" ]; then
1051 for X in data/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
1052 if [ -f "$X" ]; then
1060 if [ -f "defaultXonotic.cfg" ]; then
1061 gv=`grep "^gameversion " "defaultXonotic.cfg" | awk '{ print $2 }'`
1062 major=$(($gv / 10000))
1063 minor=$(($gv / 100 - $major * 100))
1064 patch=$(($gv - $major * 10000 - $minor * 100))
1066 s/^set g_xonoticversion [^ ]* /set g_xonoticversion $major.$minor.$patch /;
1067 s/^gameversion_min [0-9]*/gameversion_min $(( ($gv / 100) * 100 - 100 ))/;
1068 s/^gameversion_max [0-9]*/gameversion_max $(( ($gv / 100) * 100 + 199 ))/;
1069 " defaultXonotic.cfg
1070 echo "r_texture_dds_load 1" >> quake.rc
1072 "$SELF" release-buildpk3-transform-$transform "Xonotic/temp"
1074 zip -9r "../../$dst" . ########### 7za a -tzip -mx=9 "../../$dst" .
1079 stamp=`cat Xonotic/stamp.txt`
1085 dst="data/xonotic-$stamp-${dst#data/xonotic-}"
1091 while [ "$#" -gt 1 ]; do
1092 "$SELF" release-buildpk3 "$src" "Xonotic/$dst$2.pk3" "$1"
1098 "$SELF" release-buildpk3s data/font-nimbussansl.pk3dir raw ''
1099 "$SELF" release-buildpk3s data/xonotic-data.pk3dir normal '' raw '-raw' low '-low' lowdds '-lowdds'
1100 "$SELF" release-buildpk3s data/xonotic-maps.pk3dir normal '' raw '-raw' low '-low' lowdds '-lowdds'
1101 "$SELF" release-buildpk3s data/xonotic-music.pk3dir raw '' low '-low'
1102 "$SELF" release-buildpk3s data/xonotic-nexcompat.pk3dir low ''
1104 release-pack-needsx11)
1107 startx "$SELF" release-pack -- /usr/bin/Xvfb :7
1110 "$SELF" release-pack
1115 stamp=`cat Xonotic/stamp.txt`
1116 zip -9r Xonotic-common.zip \
1118 Xonotic/darkplaces-src \
1120 Xonotic/fteqcc-src \
1126 Xonotic/data/font-nimbussansl-$stamp.pk3
1127 cp Xonotic-common.zip Xonotic.zip
1128 zip -0r Xonotic.zip \
1129 Xonotic/data/xonotic-$stamp-data.pk3 \
1130 Xonotic/data/xonotic-$stamp-maps.pk3 \
1131 Xonotic/data/xonotic-$stamp-music.pk3 \
1132 Xonotic/data/xonotic-$stamp-nexcompat.pk3
1133 cp Xonotic-common.zip Xonotic-low.zip
1134 zip -0r Xonotic-low.zip \
1135 Xonotic/data/xonotic-$stamp-data-low.pk3 \
1136 Xonotic/data/xonotic-$stamp-maps-low.pk3 \
1137 Xonotic/data/xonotic-$stamp-music-low.pk3 \
1138 Xonotic/data/xonotic-$stamp-nexcompat.pk3
1139 cp Xonotic-common.zip Xonotic-lowdds.zip
1140 zip -0r Xonotic-lowdds.zip \
1141 Xonotic/data/xonotic-$stamp-data-lowdds.pk3 \
1142 Xonotic/data/xonotic-$stamp-maps-lowdds.pk3 \
1143 Xonotic/data/xonotic-$stamp-music-low.pk3 \
1144 Xonotic/data/xonotic-$stamp-nexcompat.pk3
1145 cp Xonotic-common.zip Xonotic-high.zip
1146 zip -0r Xonotic-high.zip \
1147 Xonotic/data/xonotic-$stamp-data-raw.pk3 \
1148 Xonotic/data/xonotic-$stamp-maps-raw.pk3 \
1149 Xonotic/data/xonotic-$stamp-music.pk3 \
1150 Xonotic/data/xonotic-$stamp-nexcompat.pk3
1151 rm -f Xonotic-common.zip
1154 "$SELF" release-prepare
1155 "$SELF" release-maps &
1156 "$SELF" release-engine &
1159 "$SELF" release-pack-needsx11
1167 echo " $SELF push [-s]"
1168 echo " $SELF branches"
1169 echo " $SELF branch [<remote>] <branchname>"
1170 echo " $SELF branch <remote> <branchname> <srcbranchname>"
1171 echo " $SELF checkout [<remote>] <branchname>"
1172 echo " $SELF compile [-c|-n] [<client>] <options>"
1173 echo " $SELF run [<client>] <options>"
1174 echo " $SELF each <command>"